=== debian/changelog ===
o-saft (22.11.22-1) unstable; urgency=medium

  * New upstream version 22.11.22
  * Bump Standards-Version to 4.6.1
  * d/p/install_only_important_files.patch: Update patch

 -- Samuel Henrique <samueloph@debian.org>  Sun, 18 Dec 2022 15:32:13 +0000
