=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# make and make all print a help output only.
# this package only needs the install target.
override_dh_auto_build:
	:

override_dh_auto_test:
	:

override_dh_auto_install:
	mkdir -p debian/o-saft/usr/share/o-saft/
	sh INSTALL.sh debian/o-saft/usr/share/o-saft/
	dh_bash-completion
