=== debian/tests/control ===
Test-Command: o-saft +list
Restrictions: superficial
